clc;
clear

% Import data
importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/Data_q');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/mUSIIP.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/mUSUN.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/lynx.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/ssn_yearly.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/SmoothSSN.xls')
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/Entry.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/Exit.xls');
%
% Selecting and filtering
y = 100*(log(IIP) - lag(log(IIP),4)); y=y(5:end);                  % US IIP in monthly growth rate
%y = 100*(log(mUN) - lag(log(mUN),12)); y=y(13:end);                   % US UNEMPLOYEMNT RATE in levels                                                                      
%y = log10(LYNX);                                                         % Canadian Lynx
%y = sqrt(SSN(1:end-3));                                                  % Yearly SSN (use square root transformation)
%y = log(MSmoothSSN(1213:end));                                           % Monthly Smoothed SSN (log tansformation)
%y = 100*(log(Entry) - lag(log(Entry),4))/4; y=y(5:end);
%y = 100*(log(Exit) - lag(log(Exit),4))/4; y=y(5:end);
%y = y - lag(y,1) ;  % (eventually in change rate)
%Some general parameters
T = length(y);
c = mean(y);

%Some change in name of variables
F = y;
mu = mean(F,1);
sigma = var(F);
T=length(F);
Pdens=zeros(T,1);
n = 6;
%parameters for different typws of SR.
a=0.1;
aleph=0.5;
k=1;
d=2;
beta=0.3;
thresh = 7.5;
%Average the Predictive densities (or Fan Chart upper-lower percentiles).
for i=1:T
Pdens(i,:) = (1/size(F,2))*(sum(pdf('norm',F(i,:),mu,sigma),2));
end
y=Pdens;

%Start with Scoring Rules
H=1; %Horizon
h=1;
fore=y; %Change names

%Estimate AR
O = ones(length(y),1);
y_ar=ols(y, [O lag(y,1), lag(y,2), lag(y,3), lag(y,4)]);
yhat_ar = y_ar.yhat;
lambda_ar = y_ar.beta;
[LogLik_ar] = LLF(T,y_ar.sige,y_ar.bstd);

%Estimate MR-STAR
O = ones(length(y),1);
X = [O, lag(y,1) lag(y,2) lag(y,3), lag(y,4)]; % AR(6) for IP, AR(4) for UN, AR(5) for YSSN, logSSN, sqrt MSSN, AR(6) for DLMSSN, AR(7) for LYNX
W = [];         % Matrix of exogenous covariates
q = lag(y,1);   % 5 for IP, 2 for UN, 1 for SSN, 4 for LYNX
T = length(y);
nX = size(X,2); % # of covariates
nW = 0;         % # of Exogenous variables
M = [];         % Max # of Regimes (if empty the function compute it automatically)
rob = 1;        % HAC-robust test ?
flag = 1;       % the q is part of the covariates ?
sig = 0.01;      % nominal size (0.01 for IP and UN, 0.5 YSSN, 0.05 for LYNX)
m=1; 
%initial values
gamma_0=0;
gamma1_0=0;
gamma2_0=0;
%p = mbic(y, O, X, 12);
% Call the function for MR-STAR model
[yhat_mrstar,ehat_mrstar,alpha,beta,lambda,gamma,c,se,G,sigma_mrstar,fX,pval_lin] = mrstar(y,X,W,q,T,nX,nW,M,rob,flag,sig);
[LogLik_mrstar] = LLF(T,sigma_mrstar,ehat_mrstar);
% Call the function for GSTAR model
[alpha_gstar,beta_gstar,lambda_gstar,gamma1,gamma2,c_gstar,fX_gstar,yhat_gstar,ehat_gstar,G_gstar,sigma_gstar,se_gstar]=parestGSTARlm(y,X,W,q,T,nX,nW,m,gamma1_0,gamma2_0,c(1));
[LogLik_gstar] = LLF(T,sigma_gstar,ehat_gstar);
%Compute SR for AR, MRSTAR and GSTAR
[qsr_ar,wps_ar,wps1_ar,wps2_ar,wps3_ar,wps4_ar,wps5_ar,pseudosph_ar,wpsph_ar,wpsph1_ar,wpsph2_ar,wpsph3_ar,wpsph4_ar,wpsph5_ar,logS_ar,IntS_ar,TsallisS_ar,ES_ar,GES_ar,PSpectrum_ar,crps_ar,quant_ar,CLS_ar,CSL_ar,HS_ar,LCS_ar]=scorings(yhat_ar,LogLik_ar,T,yhat_ar,thresh,a,aleph,k,d,beta,1,mean(y),1);
[qsr_mrstar,wps_mrstar,wps1_mrstar,wps2_mrstar,wps3_mrstar,wps4_mrstar,wps5_mrstar,pseudosph_mrstar,wpsph_mrstar,wpsph1_mrstar,wpsph2_mrstar,wpsph3_mrstar,wpsph4_mrstar,wpsph5_mrstar,logS_mrstar,IntS_mrstar,TsallisS_mrstar,ES_mrstar,GES_mrstar,PSpectrum_mrstar,crps_mrstar,quant_mrstar,CLS_mrstar,CSL_mrstar,HS_mrstar,LCS_mrstar] = scorings(yhat_mrstar,LogLik_mrstar,T,yhat_mrstar,thresh,a,aleph,k,d,beta,1,mean(y),1);
[qsr_gstar,wps_gstar,wps1_gstar,wps2_gstar,wps3_gstar,wps4_gstar,wps5_gstar,pseudosph_gstar,wpsph_gstar,wpsph1_gstar,wpsph2_gstar,wpsph3_gstar,wpsph4_gstar,wpsph5_gstar,logS_gstar,IntS_gstar,TsallisS_gstar,ES_gstar,GES_gstar,PSpectrum_gstar,crps_gstar,quant_gstar,CLS_gstar,CSL_gstar,HS_gstar,LCS_gstar] = scorings(yhat_gstar,LogLik_gstar,T,yhat_gstar,thresh,a,aleph,k,d,beta,1,mean(y),1);
SR_ar = [qsr_ar,wps_ar,wps1_ar,wps2_ar,wps3_ar,wps4_ar,wps5_ar,pseudosph_ar,wpsph_ar,wpsph1_ar,wpsph2_ar,wpsph3_ar,wpsph4_ar, wpsph5_ar, logS_ar,IntS_ar,TsallisS_ar,ES_ar,GES_ar,PSpectrum_ar,crps_ar,quant_ar,CLS_ar,CSL_ar,HS_ar,LCS_ar];
SR_mrstar = [qsr_mrstar,wps_mrstar,wps1_mrstar,wps2_mrstar,wps3_mrstar,wps4_mrstar,wps5_mrstar,pseudosph_mrstar,wpsph_mrstar,wpsph1_mrstar,wpsph2_mrstar,wpsph3_mrstar,wpsph4_mrstar,wpsph5_mrstar,logS_mrstar,IntS_mrstar,TsallisS_mrstar,ES_mrstar,GES_mrstar,PSpectrum_mrstar,crps_mrstar,quant_mrstar,CLS_mrstar,CSL_mrstar,HS_mrstar,LCS_mrstar];
SR_gstar = [qsr_gstar,wps_gstar,wps1_gstar,wps2_gstar,wps3_gstar,wps4_gstar,wps5_gstar,pseudosph_gstar,wpsph_gstar,wpsph1_gstar,wpsph2_gstar,wpsph3_gstar,wpsph4_gstar,wpsph5_gstar,logS_gstar,IntS_gstar,TsallisS_gstar,ES_gstar,GES_gstar,PSpectrum_gstar,crps_gstar,quant_gstar,CLS_gstar,CSL_gstar,HS_gstar,LCS_gstar];
%Compute AG test statistic for comparison of AR vs MRSTAR;
Delta_1 =  SR_mrstar - SR_ar ;
sigma_1 = 1/(T+H-1)*sum(kron(mean(fore,2), Delta_1)).^2;
t_val_1 = sqrt(n)*(Delta_1./sigma_1);
CDF_1 = cdf('t', t_val_1, T+H-1);
Pval_1 = 1-CDF_1;
%Compute AG test statitic for comparison of MRSTAR vs GSTAR;
Delta_2 =  SR_gstar - SR_mrstar;
sigma_2 = 1/(T+H-1)*sum(kron(mean(fore,2), Delta_2)).^2;
t_val_2 = sqrt(n)*(Delta_2./sigma_1);
CDF_2 = cdf('t', t_val_2, T+H-1);
Pval_2 = 1-CDF_2;

%% RESULTS
disp('------------------------------------------------------------------------------------------------------------------------------------------------------------------')
disp('            SCORING RULES for the ESTIMATED MODELS            ')
disp('------------------------------------------------------------------------------------------------------------------------------------------------------------------')
disp('          MRSTAR        |      AR   |     sigma_n    |      t_n      |      Pval     ')
disp(['QSR: ', num2str(qsr_mrstar), '     | ', num2str(qsr_ar) '   | ', num2str(sigma_1(1)), '   |  ', num2str(t_val_1(1)), '   |   ',  num2str(Pval_1(1))])
disp('        ')
disp(['LogS: ', num2str(logS_mrstar),'        | ',num2str(logS_ar) '  |  ', num2str(sigma_1(15)), '  |  ', num2str(t_val_1(15)), '  |   ',  num2str(Pval_1(15))])
disp('        ')
disp(['CRPS: ', num2str(crps_mrstar),'     | ',num2str(crps_ar) '  |  ', num2str(sigma_1(21)), '  |  ', num2str(t_val_1(21)), '   |  ',  num2str(Pval_1(21))])
disp('        ')
disp(['QuantS: ', num2str(quant_mrstar),'     | ',num2str(quant_ar) ' | ', num2str(sigma_1(22)),'| ', num2str(t_val_1(22)), ' |  ',  num2str(Pval_1(22))])
disp('------------------------------------------------------------------------------------------------------------------------------------------------------------------')
%% RESULTS
disp('------------------------------------------------------------------------------------------------------------------------------------------------------------------')
disp('------------------------------------------------------------------------------------------------------------------------------------------------------------------')
disp('          GSTAR        |      MRSTAR   |     sigma_n    |      t_n      |      Pval     ')
disp(['QSR: ', num2str(qsr_gstar), '   | ', num2str(qsr_mrstar) '   | ', num2str(sigma_2(1)), '   |  ', num2str(t_val_2(1)), '   |   ',  num2str(Pval_2(1))])
disp('        ')
disp(['LogS: ', num2str(logS_gstar),'         | ',num2str(logS_mrstar) '  |  ', num2str(sigma_2(15)), '  |  ', num2str(t_val_2(15)), '  |   ',  num2str(Pval_2(15))])
disp('        ')
disp(['CRPS: ', num2str(crps_gstar),'     | ',num2str(crps_mrstar) '  |  ', num2str(sigma_2(21)), '  |  ', num2str(t_val_2(21)), '   |  ',  num2str(Pval_2(21))])
disp('        ')
disp(['QuantS: ', num2str(quant_gstar),'     | ',num2str(quant_mrstar) ' | ', num2str(sigma_2(22)),'| ', num2str(t_val_2(22)), ' |  ',  num2str(Pval_2(22))])
disp('------------------------------------------------------------------------------------------------------------------------------------------------------------------')