% This file replicates forecasting statistics in Tables 2 and 3 of Main Text and can be used also for Table 10 of Supplement of Zanetti Chini (2018) 
clear; clc;
% Read data 
randn('state', 535621);
importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/Data_q');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/mUSIIP.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/mUSUN.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/lynx.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/ssn_yearly.xls')
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/Entry.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/Exit.xls');
%
% Select data
data = 100*(log(UNRATE) - lag(log(UNRATE),1)); data=data(9:end);         % US IIP 
%data = 100*(log(mUN) - lag(log(mUN),12))/12; data=data(13:end);           % US UNEMPLOYEMNT RATE                                                                       
%data = log10(LYNX);                                                       % Canadian Lynx
%data = sqrt(SSN(1:end-3));                                                 % Yearly SSN (use square root transformation)
%data = 100*(log(Entry) - lag(log(Entry),4))/4; data=data(5:end);
%data = 100*(log(Exit) - lag(log(Exit),4))/4; data=data(5:end);                                        % Monthly Smoothed SSN (log tansformation)
%data = y - lag(y,1) ; (eventually in change rate)
c = mean(data);
% Prepare the linear AR(p) models
T=size(data,1);
O = ones(T,1);
x0 = [O lag(data,1) ];
%x1 = [O lag(data,1) lag(data,2) lag(data,3)   ];
x1 = [O lag(data,1) lag(data,2) lag(data,3) lag(data,4) ];
%x1 = [O lag(data,1) lag(data,2) lag(data,3) lag(data,4) lag(data,5) lag(data,6) lag(data,7) lag(data,8) lag(data,9)  ];
%x1 = [O lag(data,1) lag(data,2) lag(data,3) lag(data,4) lag(data,5) lag(data,6) lag(data,7) lag(data,8) lag(data,9) lag(data,10) lag(data,11) lag(data,12) ];
h=size(x1,2)-1; 
%
%
%Open files with estimate vectors (SELECT only I and III or II and IV row
%of any single group! 

%open qIP_yhat_mrstar.mat; yhat=ans.yhat;
%open qIP_yhat_gstar.mat; yhat=ans.yhat_gstar;
%open qIP_ehat_mrstar.mat; ehat=ans.ehat;
%open qIP_ehat_gstar.mat; ehat=ans.ehat_gstar;

%open IPyhat_mrstar.mat; yhat=ans.yhat;
%open IPyhat_gstar.mat; yhat=ans.yhat_gstar;
%open IPehat_mrstar.mat; ehat=ans.ehat;
%open IPehat_gstar.mat; ehat=ans.ehat_gstar;
%
open qUN_yhat_mrstar.mat; yhat=ans.yhat;
%open qUN_yhat_gstar.mat; yhat=ans.yhat_gstar;
open qUN_ehat_mrstar.mat; ehat=ans.ehat;
%open q_UNehat_gstar.mat; ehat=ans.ehat_gstar;
%
%open UNyhat_mrstar.mat; yhat=ans.yhat;
%open UNyhat_gstar.mat; yhat=ans.yhat_gstar;
%open UNehat_mrstar.mat; ehat=ans.ehat;
%open UNehat_gstar.mat; ehat=ans.ehat_gstar;
%
%
%open ENTyhat_mrstar.mat; yhat=ans.yhat;
%open ENTyhat_gstar.mat; yhat=ans.yhat_gstar;
%open ENTehat_mrstar.mat; ehat=ans.ehat;
%open ENTehat_gstar.mat; ehat=ans.ehat_gstar;
%
%open EXTyhat_mrstar.mat; yhat=ans.yhat;
%open EXTyhat_gstar.mat; yhat=ans.yhat_gstar;
%open EXTehat_mrstar.mat; ehat=ans.ehat;
%open EXTehat_gstar.mat; ehat=ans.ehat_gstar;
%Some change in name of variables

F = yhat;
mu = mean(F,1);
sigma = var(F);
T=length(F);
Pdens=zeros(T,1);
n = 6;
%
%Average the Predictive densities (or Fan Chart upper-lower percentiles).
%
for i=1:T
Pdens(i,:) = (1/size(F,2))*(sum(pdf('norm',F(i,:),mu,sigma),2));
end
y=Pdens;
%
%
%   Then, select bandwidth for the Rolling Window
%
alpha = 0.05;                    % 0.01 for IP and UN, 0.05 for others.
h=1;                             %h-step ahead estimation
bw = 100;                        % rolling window
oos_reg0=[]; oos_reg1=[]; yoos=[]; predreg=[];
% without out of sample
for i=1:T-(bw+h)+1
    [B0 Bint0 R0] = regress(data(i:i+bw-1,:),x0(i:i+bw-1,:));
    %[B1 Bint1 R1] = regress(data(i:i+bw-1,:),x1(i:i+bw-1,:));
    R1= ehat(i:i+bw-1,:);
    
    oos_reg0(i,:)=  [ x0(bw+i,:)];
    oos_reg1(i,:)=  [ yhat(bw+i,:)];
    yoos(i,:) = data(bw+i,:);
end

% Finally, use Point forecast statsitics...
%
%B0=[B(1); zeros(p-1,1)];
%predreg= ((ones(size(B(2:end))) + B(2:end)).^h-1).*B0 + B(2:end).^h)*oos_reg(:,2:end);
predreg= oos_reg0*(B0.^h);
%[ME]=meanerror(yoos,predreg);
[ME]=meanerror(yoos,oos_reg1);
%[sMAPE] = medianerror(yoos, predreg);
[sMAPE] = medianerror(yoos, oos_reg1);
%[rMAE] = medianrelerror(yoos,predreg, predreg);
[rMAE] = medianrelerror(yoos,predreg, oos_reg1)
%[RMSFE] = mse(yoos,predreg);
[RMSFE] = mse(yoos,oos_reg1);

%....and Density forecast stastitics...
[logS] = logScore(oos_reg1, T);
[qsr] = qscore(R1,oos_reg1);
[QuantileS] = QuantileS(oos_reg1, alpha);
[CRPS] = CRPS(oos_reg1, c);
%
%...and test for EQUAL PREDICTIVE ABILITY.
[DM, DM_pval] = dmtest(R0, R1, h);
[Berk_statistic, Berkowitz_pvalue, transformed_x]=berkowitz(oos_reg1); 
[CPA_pval]=CPAtest(R0,R1,h, alpha, 2);
% Use some commands for setting the estimation period:
%for IIP R=500, first estimation period is 1982-9, for UN R=500, first estimation period is 1983-9 ...
%For ENTRY and EXIT R=50, first estimation period is ; 
time=calendar(1982,9,T,'m'); tds=calendar_plot(1982,9,T,'m'); 
%[result_DMW]= testsoos2(oos_reg1,yoos,1983,9,time,tds);
%[results_Berkowitz_DH] = testsofuniformityInvNorm(oos_reg1);
%
%Eventually, use Giacomini-Rossi Fluctiation test (if works...) 
%
%[result_GR]= testsoos3(R0,R1,1947,1,time,tds,bw);
%[result_GRonetime]= testsoosBREAK(R0,R1,1947,1,time,tds,bw);
%
% AND PLOT THE RESTULTS
disp('') , disp('FORECAST EVALUATION RESULTS' ) , disp('')
disp('-----------------------------------------------') 
disp('') , disp( sprintf('Nominal Size: %1.2f' , alpha )) , disp('')
disp('') , disp( sprintf('h-step ahead: %1.0f' , h )) , disp('')
disp('') , disp( sprintf('Rolling Window length: %1.0f' , bw )) , disp('')
disp('-----------------------------------------------') 
disp('') , disp('POINT Forecasts' ) , disp('')
disp('-----------------------------------------------') 
disp('') , disp( sprintf('Mean Forecast Error: %1.4f' , ME )) , disp('')
disp('') , disp( sprintf('Symmetric Mean Percentage Error: %1.4f' , sMAPE )) , disp('')
disp('') , disp( sprintf('Relative Mean Absolute Error: %1.4f' , rMAE )) , disp('')
disp('') , disp( sprintf('Root Mean Forecast Error: %1.4f' , RMSFE )) , disp('')
%disp('') , disp( sprintf('Nominal Risk level: %1.2f' , alpha) ) , disp('')
disp('-----------------------------------------------') 
disp('') , disp('DENSITY Forecasts' ) , disp('')
disp('-----------------------------------------------') 
disp('') , disp( sprintf('Logarhithmic Score: %1.4f' , logS ) ) , disp('')
disp('') , disp( sprintf('Quadratic Score: %1.4f' , qsr ) ) , disp('')
disp('') , disp( sprintf('CRPS Score: %1.4f' , CRPS ) ) , disp('')
disp('') , disp( sprintf('Quantile Score: %1.4f' , QuantileS ) ) , disp('')
disp('-----------------------------------------------') 
disp('') , disp( sprintf('Diebold-Mariano test: %1.4f' , DM_pval ) ) , disp('')
%disp('') , disp( sprintf('Clark-West: %1.4f' , result_DMW(2,2) ) ) , disp('')
disp('') , disp( sprintf('CPA Test: %1.4f' , CPA_pval ) ) , disp('')
%disp('') , disp( sprintf('Berkowitz Test: %1.4f' , results_Berkowitz_DH.lbothPvalue ) ) , disp('')
%disp('') , disp( sprintf('DH Test: %1.4f' , results_Berkowitz_DH.dhPvalue ) ) , disp('')
%disp('') , disp( sprintf('GR Test: %1.4f' , result_GR(2,2) ) ) , disp('')