function [h, mu, G1]= G1_glstar1(gamma1, gamma2,eta)
%This function build the G function of GLSTAR1 model
                                
%Define the Stukel function (fromula 2-3)
h11 = (gamma1^(-1))*(exp(gamma1.*abs(eta)) - 1) ; 
h12 = eta  ;
h13 = (-gamma1^(-1))*log(1 - gamma1.*abs(eta))  ; 

h21 = (-gamma2^(-1))*(exp(gamma2.*abs(eta)) - 1)  ;
h22 = eta ;
h23 = (gamma2^(-1))*log(1 - gamma2.*abs(eta))  ; 
         
if gamma1 > 0
    h1 = h11;
elseif gamma1 == 0
    h1 = h12;
else h1 = h13;
end

if gamma2 > 0
   h2 = h21;
elseif gamma2 == 0
    h2 = h22 ;
else h2 = h23;
end

%Define: h_gamma, mu_gamma and G
h = ((eta) <=0).*(h2) + ((eta) >=0).*(h1);
mu = exp(h)./(1 + exp(h));
G1 = (1 + exp(-h)).^(-1)-0.5;
end