function [h_2, mu_2, G2] = G2_glstar1(gamma3, gamma4, eta1)
%This function build the additive nonlinar function G2 of GLSTAR1 model
                                
%Define the Stukel function (fromula 2-3)
h111 = (gamma3^(-1))*(exp(gamma3.*abs(eta1)) - 1); 
h121 = zeros(size(eta1));
h131 = (-gamma3^(-1))*log(1 - gamma3.*abs(eta1)); 

h211 = (-gamma4^(-1))*(exp(gamma4.*abs(eta1)) - 1);
h221 = zeros(size(eta1)) ;
h231 = (gamma4^(-1))*log(1 - gamma4.*abs(eta1)); 
         
if gamma3 > 0
    h1_1 = h111;
elseif gamma3 == 0
    h1_1 = h121;
else h1_1 = h131;
end

if gamma4 > 0
   h2_1 = h211;
elseif gamma4 == 0
    h2_1 = h221 ;
else h2_1 = h231;
end

%Define: h_gamma, mu_gamma and G2
h_2 = ((eta1) <=0).*(h2_1) + ((eta1) >=0).*(h1_1);
mu_2 = exp(h_2)./(1 + exp(h_2));
G2 = (1 + exp(-h_2)).^(-1) -0.5;
end