% This script replicates Figure 1a in EZC            
%
clear
clc
% Magic numbers
eta = -6:.1:6;                  
s = lag(eta,0);
c = mean(eta);

% Derived numbers
N = length(eta);

% Declare the SLN2002 parametrization for function "h(gamma)"
[GL1] = h_SLN(4, .25, 1, s, c);
[GL2] = h_SLN(1, 2, .25, s, c);
[GL3] = h_SLN(.25, 2, 2, s, c);
[GL4] = h_SLN(.25, 4, 1, s, c);
[GL5] = h_SLN(.25, 4, .25, s, c);
[GL6] = h_SLN(.25, 4, 4, s, c);


%Results
figure(1)
p = plot(eta, GL1, eta, GL2, eta, GL3, eta, GL4, eta, GL5, eta, GL6); %The logistic function on the range
xlabel('X');                          
ylabel('G(\gamma_1, \gamma_2, \theta; X)');                       
title('The SLN (2002) model');
legend('\gamma_1 = 4, \gamma_2 = .25, \theta = .25',...
       '\gamma_1 = 1, \gamma_2 = 2, \theta = .25',... 
       '\gamma_1 = .25, \gamma_2 = 2, \theta = 2',...
       '\gamma_1 = .25, \gamma_2 = 4, \theta = 1',...
       '\gamma_1 = .25, \gamma_2 = 4, \theta = .25',...
       '\gamma_1 = .25, \gamma_2 = 4, \theta = 4', 0);  %Set up the legend
set(p,'LineWidth',2)