% This script perform an example of GESTR model (formula 6)
%
clear
clc
% Magic numbers
eta = -6:.1:6;   
c = mean(eta)+2;
s = lag(eta,1);
eta_t = (s - c).^2;

%Case 1: gamma1 varies, gamma2 constant to 0
[h1, MU1, G1] = h_gamma(eta_t, -3, 0);
[h2, MU2, G2] = h_gamma(eta_t, -1, 0);
[h3, MU3, G3] = h_gamma(eta_t, 1, 0);
[h4, MU4, G4] = h_gamma(eta_t, 3, 0);

%Case 2: gamma1 constant to 0, gamma2 varies;
[h5, MU5, G5] = h_gamma(eta_t, 0, -3);
[h6, MU6, G6] = h_gamma(eta_t, 0, -1);
[h7, MU7, G7] = h_gamma(eta_t, 0, 1);
[h8, MU8, G8] = h_gamma(eta_t, 0, 3);

%PLOT RESULTS

figure(1)
subplot(2,1,1)
p1 = plot(eta, G1, eta, G2, eta, G3, eta, G4)
xlabel('eta')                          
ylabel('G(eta_t, gamma1, gamma2)')                       
title('GESTAR: changes in gamma1 ("h"-notation)')
legend('gamma1= -3, gamma2= 0', 'gamma1= -1, gamma2= 0', 'gamma1= 1, gamma2= 0', 'gamma1= 3, gamma2= 0', 3)
set(p1,'LineWidth',3)
subplot(2,1,2)
axis tight;
subplot(2,1,2)
p2 = plot(eta, G5, eta, G6, eta, G7, eta, G8)
xlabel('eta')                          
ylabel('G(eta_t, gamma1, gamma2)')                       
title('GESTAR: changes in gamma2 ("h"-notation)')  
legend('gamma1= 0, gamma2= -3', 'gamma1= 0, gamma2= -1', 'gamma1= 0, gamma2= 1', 'gamma1= 0, gamma2= 3', 3)
set(p2,'LineWidth',3)
axis tight;