function [Gcc] = Gcc(gamma1, gamma2, h, eta, eta_t, s, T)
%This file compute the first derivatives of G on gamma2.


%Define the DERIVATIVES of Stukel function (formulas 73 and 74 in EZC)
dh11 = zeros(T,1);
dh12 = zeros(T,1);
dh13 = zeros(T,1);

dh21 = zeros(T,1);
dh22 = zeros(T,1);
dh23 = zeros(T,1);
         
if gamma1 > 0
    dh1 = dh11;
elseif gamma1 == 0
    dh1 = dh12;
else dh1 = dh13;
end

if gamma2 > 0
   dh2 = dh21;
elseif gamma2 == 0
    dh2 = dh22 ;
else dh2 = dh23;
end
dh1 = dh1(length(eta),1);
dh2 = dh2(length(eta),1);

%Set the components of eq 70
g = exp(-h.*(eta_t));
f = -h.*(eta_t);
df = ((s) <=0).*(dh2) + ((s) >=0).*(dh1);
dg = g.*df;
D2 = 1 + g.^2 + 2*g;
% Compute G_gamma1 (eq. 70)
Gcc = (dg.*f.*df)./D2;
end