function [LM_GSTARnoadd, pval_GSTARnoadd] = dtest_noaddasy_GSTAR(ehat, s, X, T, G_stuk, Ggamma1, Ggamma2, Gc)
%This function provides the LM test and p-value for test for NO ADDITIVE
%ASYMMETRY

%Define the matrix of regressors 
U = ehat;
p=size(X,2);
O=ones(1,p);
Z = X';
ZG1=Z'.*kron(O,G_stuk);
ZGgamma1=Z'.*kron(O,Ggamma1);
ZGgamma2=Z'.*kron(O,Ggamma2);
ZGc=Z'.*kron(O,Gc);

%Define the matrix of covariates for the alternative of additive asymmetry
V = [ s, s.^2, s.^3 ];  %H_03'
V2 = [ s, s.^2];        %H_02'
V1 =  s ;               %H_01'

% THE NULL HP H_00' is V0 = [], that is an empty vector, so we can omit it

% Matrix of covariates UNDER THE NULL of NO ADDITITIVE ASYMMETRY. 
z0 = [ Z', ZG1, ZGgamma1, ZGgamma2, ZGc]; 
z01 = [V1 Z', ZG1, ZGgamma1, ZGgamma2, ZGc]; 
z02 = [V2 Z', ZG1, ZGgamma1, ZGgamma2, ZGc];
% Matrix of covariates UNDER THE ALTERNATIVE. 
z1 = [V, Z', ZG1];

%Regress and store the etimates and residuals under H0 - 
%NOTE: WE USE THE HETERO-ROBUST VERSION of
%the test while regressing U=[hat_u_tvgstar(t)] on z.
params0_ols = ols(U, z0);
%params0_est = [params0_ols(1:end).beta];
RES0 = [params0_ols(1:end).resid];
SE0 = [params0_ols(1:end).bstd];
SSR0 = sum(RES0.^2);
sigma20 = (1/T)*SSR0;
%Regress and store the etimates and residuals under H1
params1_ols = ols(U, z1);
%params1_est = [params1_ols(1:end).beta];
RES1 = [params1_ols(1:end).resid];
SE1 = [params1_ols(1:end).bstd];
SSR1 = sum(RES1.^2);
sigma21 = (1/T)*SSR1;

%F-statistic
n = size(z0,2);
LM_GSTARnoadd = ((SSR0-SSR1)/(3*p))/(SSR1/(T-n-3*p));
pval_GSTARnoadd = 1-cdf('f', LM_GSTARnoadd, 3*p, T-n-3*p);
end