function [y_gstar, u_scgstar, y_scgstar, p, bar_z, Z, v] = sim_scGSTAR(y, phi0, phi, theta0, theta, T, G, eps, q, rho)

%Define the model without SC
p = T-length(y);
bar_z = [lag(y,1), lag(y,2)]';
phi = [phi0, phi']';
theta = [theta0, theta']';
Z = [ones(1,length(bar_z))', bar_z']';

eps1 = eps(p+1:end)';
y_gstar = phi'*Z + theta'*Z.*G' + eps1 ;
u_gstar = y_gstar - phi'*Z - theta'*Z.*G';

%Define the parameters for SC
v = zeros(length(u_gstar),q);   %preallocate the vector v
for j=1:q;
    v(:,j) = lag(u_gstar,j) ;   %define v=[u_gstar(t-1),...,u_gstar(t-q)]
end
Rho=repmat(rho,1,q);                %define the coefficient matrix Rho
u_scgstar = v*Rho' + eps1';       %define the serially correlated errors
y_scgstar = phi'*Z + theta'*Z.*G' + u_scgstar'; % define the y(t) series with SC
end